using System;
using System.Collections.Generic;

namespace TakmicenjePetlja2
{
    class Program
    {
        public static long Proveri(long[,] niz, long M, long N, long j, long i, (long, long) zauzeto)
        {

            if (i != N - 1 || j != M - 1)
            {
                long dole = 0;
                if (j != M)
                {
                    if (zauzeto != (i,j+1)) dole = Proveri(niz, M, N, 1 + j, i, zauzeto);
                    else dole = 0;
                }
                else j--;
                long desno = 0;
                if (i != N)
                {
                    if (zauzeto != (i+1,j)) desno = Proveri(niz, M, N, j, 1+i, zauzeto);
                    else desno = 0;
                }
                else i--;
                if (dole == 0 && desno == 0) return 0;
                else if (dole == 0) return desno + niz[i, j];
                else if (desno == 0) return dole + niz[i, j];
                else if (dole > desno) return desno + niz[i, j];
                else return dole + niz[i, j];
            }
            else return niz[N - 1, M - 1];
        }
        static void Main(string[] args)
        {
            string brojevi = "";
            long N = 0;
            long M = 0;
            foreach (char item in Console.ReadLine())
            {
                if (item != ' ') brojevi += item;
                else
                {
                    N = Convert.ToInt64(brojevi);
                    brojevi = "";
                }
            }
            M = Convert.ToInt64(brojevi);
            brojevi = "";
            int brojac = 0;
            long[,] niz = new long[N, M];

            for (int i = 0; i < N; i++)
            {
                foreach (char item in Console.ReadLine())
                {
                    if (item != ' ') brojevi += item;
                    else
                    {
                        niz[i,brojac] = Convert.ToInt64(brojevi);
                        brojevi = "";
                        brojac++;
                    }
                }
                niz[i, brojac] = Convert.ToInt64(brojevi);
                brojevi = "";
                brojac = 0;
            }
            long Q = Convert.ToInt64(Console.ReadLine());
            brojevi = "";
            (long, long) zauzeto =(0,0);
            for (int i = 0; i < Q; i++)
            {
                foreach (char item in Console.ReadLine())
                {
                    if (item != ' ') brojevi += item;
                    else
                    {
                        zauzeto.Item1 = Convert.ToInt64(brojevi)-1;
                        brojevi = "";
                    }
                }
                zauzeto.Item2 = Convert.ToInt64(brojevi)-1;
                Console.WriteLine(Proveri(niz, M, N, 0, 0,zauzeto));
                brojevi = "";
            }
        }
    }
}